"systemctl default" stops ifup@.service

Bug #1449380 reported by Martin Pitt on 2015-04-28
12
This bug affects 1 person
Affects Status Importance Assigned to Milestone
systemd (Debian)
Fix Released
Unknown
systemd (Ubuntu)
Medium
Martin Pitt
Vivid
Medium
Martin Pitt

Bug Description

Running the display-manager autopkgtest causes eth0 to get shut down:

Apr 28 08:30:15 autopkgtest ifdown[3267]: Internet Systems Consortium DHCP Client 4.3.1
Apr 28 08:30:15 autopkgtest ifdown[3267]: Copyright 2004-2014 Internet Systems Consortium.
Apr 28 08:30:15 autopkgtest ifdown[3267]: All rights reserved.
Apr 28 08:30:15 autopkgtest ifdown[3267]: For info, please visit https://www.isc.org/software/dhcp/
Apr 28 08:30:15 autopkgtest ifdown[3267]: Listening on LPF/eth0/52:54:00:12:34:56
Apr 28 08:30:15 autopkgtest ifdown[3267]: Sending on LPF/eth0/52:54:00:12:34:56
Apr 28 08:30:15 autopkgtest ifdown[3267]: Sending on Socket/fallback
Apr 28 08:30:15 autopkgtest dhclient[3301]: DHCPRELEASE on eth0 to 10.0.2.2 port 67 (xid=0x3ca4ea0a)
Apr 28 08:30:15 autopkgtest ifdown[3267]: DHCPRELEASE on eth0 to 10.0.2.2 port 67 (xid=0x3ca4ea0a)

This breaks the ssh runner.

SRU TEST CASE:
==============
- Prepare a system which uses ifupdown (e. g. a standard adt-buildvm-ubuntu-cloud VM)
- Start it, run "sudo systemctl default"
- With vivid final's systemd, this will stop <email address hidden> and hence shut down eth0. ssh and other network connections will stop.
- With this fix, <email address hidden> and eth0 should stay running/up.

Regression potential: Very low: We don't use "systemctl isolate" during regular operation, and more elaborate commands like "systemctl isolate rescue.target" are currently broken on Ubuntu anyway due to our D-Bus shutdown hack.

Martin Pitt (pitti) on 2015-04-28
Changed in systemd (Ubuntu):
status: New → In Progress
importance: Undecided → Medium
assignee: nobody → Martin Pitt (pitti)
Martin Pitt (pitti) wrote :

Targetting for SRU to vivid so that we can test this in nova.

Changed in systemd (Ubuntu Vivid):
milestone: none → vivid-updates
Martin Pitt (pitti) on 2015-04-28
summary: - display-managers autopkgtest shuts down eth0
+ "systemctl default" stops ifup@.service
Martin Pitt (pitti) wrote :

This is caused by "systemctl default" which isolates default.target and shuts down anything else. IMHO this is an actual bug, or at least unexpected/inconvenient.

I propose this fix: http://paste.ubuntu.com/10923461/ I'll discuss it with Michael Biebl, and commit it to experimental/vivid when we have an agreement.

Martin Pitt (pitti) wrote :
Changed in systemd (Ubuntu Vivid):
status: In Progress → Fix Committed
description: updated
Changed in systemd (Debian):
status: Unknown → Confirmed
Changed in systemd (Debian):
status: Confirmed → Fix Released
Brian Murray (brian-murray) wrote :

This hasn't made it to -proposed or -updates yet, setting back to Triaged.

Changed in systemd (Ubuntu Vivid):
status: Fix Committed → Triaged
Martin Pitt (pitti) on 2015-05-07
Changed in systemd (Ubuntu):
milestone: vivid-updates → none

Hello Martin, or anyone else affected,

Accepted systemd into vivid-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/systemd/219-7ubuntu5 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in systemd (Ubuntu Vivid):
status: Triaged → Fix Committed
tags: added: verification-needed
Martin Pitt (pitti) wrote :

I successfully ran the test case on the -proposed package.

tags: added: verification-done
removed: verification-needed
Launchpad Janitor (janitor) wrote :
Download full text (5.9 KiB)

This bug was fixed in the package systemd - 219-8ubuntu1

---------------
systemd (219-8ubuntu1) wily; urgency=medium

  * Merge with Debian experimental branch. Remaining Ubuntu changes:
    - Hack to support system-image read-only /etc, and modify files in
      /etc/writable/ instead.
    - Keep our much simpler udev maintainer scripts (all platforms must
      support udev, no debconf).
    - initramfs init-top: Drop $ROOTDELAY, we do that in a more sensible way
      with wait-for-root. Will get applicable to Debian once Debian gets
      wait-for-root in initramfs-tools.
    - initramfs init-bottom: If LVM is installed, settle udev,
      otherwise we get missing LV symlinks. Workaround for LP #1185394.
    - Add debian/udev.lvm2.init: Dummy SysV init script to satisfy insserv
      dependencies to "lvm2" which is handled with udev rules in Ubuntu.
    - Add debian/udev.lvm2.service to avoid running the dummy lvm2 init
      script.
    - Provide shutdown fallback for upstart. (LP: #1370329)
    - debian/extra/ifup@.service: Additionally run for "auto" class. We don't
      really support "allow-hotplug" in Ubuntu at the moment, so we need to
      deal with "auto" devices appearing after "/etc/init.d/networking start"
      already ran. (LP: #1374521) Also, check if devices are actually defined
      in /etc/network/interfaces as we don't use Debian's net.agent.
      Also run ifup in the background during boot, to avoid blocking
      network.target. (LP: #1425376)
    - ifup@.service: Drop dependency on networking.service (i. e.
      /etc/init.d/networking), and merely ensure that /run/network exists.
      This avoids unnecessary dependencies/waiting during boot and dependency
      cycles if hooks wait for other interfaces to come up (like ifenslave
      with bonding interfaces). (LP: #1414544)
    - Add Get-RTC-is-in-local-time-setting-from-etc-default-rc.patch: In
      Ubuntu we currently keep the setting whether the RTC is in local or UTC
      time in /etc/default/rcS "UTC=yes|no", instead of /etc/adjtime.
      (LP: #1377258)
    - Put session scopes into all cgroup controllers. This makes unprivileged
      user LXC containers work under systemd. (LP: #1346734)
    - systemctl: Don't forward telinit u to upstart. This works around
      upstart's Restart() always reexec'ing /sbin/init on Restart(), even if
      that changes to point to systemd during the upgrade. This avoids running
      systemd during a dist-upgrade. (LP: #1430479)
    - Drop hwdb-update dependency from udev-trigger.service, which got
      introduced in v219-stable. This causes udev and plymouth to start too
      late and isn't really needed in Ubuntu yet as we don't support stateless
      systems yet and handle hwdb.bin updates through dpkg triggers. This can
      be dropped again with initramfs-tools 0.117.
    - Lower Breaks: to plymouth version which has the udev inotify fix in
      Ubuntu.
    - Lower libappamor dep to the Ubuntu version where it moved to /lib.
    - Change systemd-sysv's conflicts to upstart-sysv. (LP: #1422681)
    - Make failure of boot-and-services NSpawn.test_boot non-fatal for now.
      This currently fails when being t...

Read more...

Changed in systemd (Ubuntu):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package systemd - 219-7ubuntu5

---------------
systemd (219-7ubuntu5) vivid; urgency=medium

  * Revert upstream commit 743970d which immediately SIGKILLs units during
    shutdown. This leads to problems like bash not being able to write its
    history, mosh not saving its state, and similar failed cleanup actions.
    (LP: #1448259)
  * ifup@.service: Set IgnoreOnIsolate, so that "systemctl default" does not
    shut down network interfaces. (LP: #1449380). Add PartOf=network.target,
    so that stopping network.target also stops network interfaces.
  * 75-persistent-net-generator.rules: Fix rules for ibmveth (it's a driver,
    not a subsystem). (LP: #1437375)
  * debian/tests/unit-config: Add tests for systemctl enable/disable on a
    SysV-only unit. Reproduces LP #1447807.
  * Fix systemctl enable for SysV scripts without a native unit. We must not
    try and enable the nonexisting unit then. (LP: #1447807)

 -- Martin Pitt <email address hidden> Thu, 07 May 2015 07:45:34 +0200

Changed in systemd (Ubuntu Vivid):
status: Fix Committed → Fix Released

The verification of the Stable Release Update for systemd has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.